#*******************************************************************************
#    Copyright (C) 2006 K. Vasudevan. Indian Institute of Technology Kanpur.
#    All Rights Reserved.
#*******************************************************************************
# Plot of the variance of the timing error vs SNR per bit for uncoded QPSK.
#*******************************************************************************
#*******************************************************************************
# Gnuplot file. To plot the graph run gnuplot and at the gnuplot prompt
# type: load "t_crb.gp"<RETURN>
# If you want the output on the screen, comment the following two lines:
# set term postscript eps color 22
# set output "t_crb.eps"
# Comment lines begin with a #.
# For help on gnuplot, run gnuplot and type the following at the gnuplot
# prompt: help
#*******************************************************************************
set term postscript eps color 22
set key box
set grid xtics ytics mytics lw 0.5, lw 0.5
set format y "%2.1e"
set output "t_crb.eps"
set logscale y
#set xlabel "SNR (dB)"
#set ylabel "Variance of timing error"
plot "t_var_piby2_128.dat" t "theta=pi/2, L=128"\
      w linespoints lt -1 lw 1 pt 2,\
     "t_var_piby4_128.dat" t "theta=pi/4, L=128"\
      w linespoints lt -1 lw 1 pt 3,\
     "t_var_piby2_64.dat" t "theta=pi/2, L=64"\
      w linespoints lt -1 lw 1 pt 5
