/******************************************************************************/
/*   Copyright (C) 2005 K. Vasudevan. Indian Institute of Technology Kanpur.  */
/*   All Rights Reserved.                                                     */
/******************************************************************************/
FILE *fp1,*fp2;                                             /* File pointers. */
/******************************************************************************/
/*                     VARIABLES RELATED TO THE FRAME.
*******************************************************************************/
int Ber;                                                   /* Bit-error-rate. */
int Tx_Samp_Cnt;                                       /* Sample count at tx. */
int Rx_Samp_Cnt;                                       /* Sample count at rx. */
int Frame_Cnt;                                                /* Frame count. */
int Sym[FRAME_SIZE];                                       /* Stores symbols. */
double Map[BPSK_SIZE];                                /* Stores BPSK mapping. */
/******************************************************************************/
/*                        TRANSMIT FILTER VARIABLES.
*******************************************************************************/
double Rand_Tx_Delay;                                        /* Random delay. */
double Re_Tx_Op;                                              /* Re. tx. o/p. */
double Im_Tx_Op;                                              /* Im. tx. o/p. */
double Tx_Flt[TX_FLT_SIZE];                               /* Transmit filter. */
double Re_Tx_Reg[TX_FLT_SIZE];                                /* Re. tx. reg. */
double Im_Tx_Reg[TX_FLT_SIZE];                                /* Im. tx. reg. */
/******************************************************************************/
/*                  VARIABLES RELATED TO THE MODULATED SIGNAL.
*******************************************************************************/
double Passband_Signal;                                   /* Passband signal. */
double Initial_Phase;                         /* Initial carrier phase at tx. */
double Theta;                                    /* Starting phase at the tx. */
/******************************************************************************/
/*                       NOISE GENERATOR VARIABLES.
*******************************************************************************/
unsigned short N1_Store[PN_SIZE];                       /* Stores PNS status. */
unsigned short N2_Store[PN_SIZE];                       /* Stores PNS status. */
double Variance;                                           /* Noise variance. */
double Inv_Twice_Noise_Var;           /* Inverse of twice the noise variance. */
double N1_Val[NVALSIZE];                         /* Contains U & G rand. var. */
/******************************************************************************/
/*               LOCAL OSCILLATOR (AT THE RECEIVER) VARIABLES.
*******************************************************************************/
double Re_LO[LO_PERIOD];                                /* Cosine term of LO. */
double Im_LO[LO_PERIOD];                                  /* Sine term of LO. */
double Re_LO_Op;                                               /* Re. LO o/p. */
double Im_LO_Op;                                               /* Im. LO o/p. */
/******************************************************************************/
/*                         MATCHED FILTER VARIABLES.
*******************************************************************************/
double Rx_Re_Sym;                                          /* Rx. re. symbol. */
double Rx_Im_Sym;                                          /* Rx. im. symbol. */
double MF[MF_SIZE];                                        /* Matched filter. */
double Re_MF_Reg[MF_SIZE];                                     /* Re. MF reg. */
double Im_MF_Reg[MF_SIZE];                                     /* Im. MF reg. */
double Re_MF_Op[RX_SAMP_SIZE];                                 /* Re. MF o/p. */
double Im_MF_Op[RX_SAMP_SIZE];                                 /* Im. MF o/p. */
/******************************************************************************/
/*                   TIMING AND CARRIER RECOVERY VARIABLES.
*******************************************************************************/
int Samp_Instant;                                        /* Sampling instant. */
int Mean_Corr_Cnt;                       /* Ctr. for the no. of correlations. */
double Re_Tim_Corr;                                /* Re. timing correlation. */
double Im_Tim_Corr;                                /* Im. timing correlation. */
double Re_Mean_Corr;                          /* Re. mean of the correlation. */
double Im_Mean_Corr;                          /* Im. mean of the correlation. */
double Re_Tim_Max;                                   /* Re. correlation peak. */
double Im_Tim_Max;                                   /* Im. correlation peak. */
double Tim_Max_Mag;                         /* Max. magnitude of correlation. */
double Est_Phase;                                 /* Estimated carrier phase. */
double Phase_Var;                                       /* Var. of phase est. */
double Tim_Var;                                          /* Var. of tim. est. */
double Re_Amp;                                              /* Re. amplitude. */
double Im_Amp;                                              /* Im. amplitude. */
double Est_Var;                                        /* Estimated variance. */
/******************************************************************************/
