/******************************************************************************/
/*   Copyright (C) 2006 K. Vasudevan. Indian Institute of Technology Kanpur.  */
/*   All Rights Reserved.                                                     */
/******************************************************************************/
/******************************************************************************/
#include "deal1type.h"
#include "deal1ext.h"
/******************************************************************************/
int Pre_Processor()
{
 Open_Files();
 Get_RRC(MF_SIZE,(double)MF_DELAY,RX_SAMP_FREQ,MF);      /* Go to deal1util.c */
 Normalize_MF();
 Print_MF();
 Print_Autocorr();
 Sim_Init();                                             /* Go to deal1init.c */
 Ck_Var();                                                 /* Go to deal1ck.c */
 return(0);
}
/******************************************************************************/
/*                                 Open files.
*******************************************************************************/
int Open_Files()
{
 fp1=fopen("deal1data/tim.dat","w");
 fp2=fopen("deal1data/env.dat","w");
 if(fp1 == NULL)
  Error_Mes(4); 
 return(0);
}
/******************************************************************************/
/*                           Normalize the MF.
*******************************************************************************/
int Normalize_MF()
{
 int cnt;
 double energy,sqrt_energy,sqrt_ip_fac;
 sqrt_ip_fac=sqrt((double)RX_IP_FAC);
 energy=0.0;
 for(cnt=ZERO;cnt<MF_SIZE;cnt++)
  energy=energy+MF[cnt]*MF[cnt];
 sqrt_energy=sqrt(energy);
 for(cnt=ZERO;cnt<MF_SIZE;cnt++)
  MF[cnt]=sqrt_ip_fac*MF[cnt]/sqrt_energy;
 return(0);
}
/******************************************************************************/
/*                         Print the matched filter.
*******************************************************************************/
int Print_MF()
{
 int inx;
 FILE *tfp;
 tfp=fopen("deal1data/mf.dat","w");
 for(inx=ZERO;inx<MF_SIZE;inx++)
  fprintf(tfp,"%lf\n",MF[inx]);
 fclose(tfp);
 return(0);
}
/******************************************************************************/
/*            Print the autocorrelation of the transmit filter.
*******************************************************************************/
int Print_Autocorr()
{
 int inx;
 double op[MF_AC_SIZE];
 FILE *tfp;
 tfp=fopen("deal1data/mfautocor.dat","w");
 Convolve(MF,MF,op,MF_SIZE,MF_SIZE);                     /* Go to deal1util.c */
 for(inx=ZERO;inx<MF_AC_SIZE;inx++)
  fprintf(tfp,"%lf\n",op[inx]);
 fclose(tfp);
 return(0);
}
/******************************************************************************/
