#*******************************************************************************
#    Copyright (C) 2008 K. Vasudevan. Indian Institute of Technology Kanpur.
#    All Rights Reserved.
#*******************************************************************************
# Plot of the bit error rates for  turbo coded QPSK. Freq. offset is 30% of
# symbol-rate.
#*******************************************************************************
#*******************************************************************************
# Gnuplot file. To plot the graph run gnuplot and at the gnuplot prompt
# type: load "uc_qpsk.gp"<RETURN>
# If you want the output on the screen, comment the following two lines:
# set term postscript eps color 22
# set output "uc_qpsk.eps"
# Comment lines begin with a #.
# For help on gnuplot, run gnuplot and type the following at the gnuplot
# prompt: help
#*******************************************************************************
set term postscript eps color 22
set key left bottom box
set grid xtics ytics mytics lw 0.5, lw 0.5
set format y "%2.1e"
set output "oqpsk_tc_ber_3T.eps"
set logscale y
#set xlabel "E_b/N_0 (dB)"
#set ylabel "Bit error rate"
plot "berp99_3T.dat" t\
     "rho=0.99"\
      w linespoints lt -1 lw 1 pt 1,\
     "berp995_3T.dat" t "rho=0.995"\
      w linespoints lt -1 lw 1 pt 2,\
     "berp999_3T.dat" t "rho=0.999"\
      w linespoints lt -1 lw 1 pt 3,\
     "berc.dat" t "Coherent"\
      w linespoints lt -1 lw 1 pt 4
