/******************************************************************************/
/*   Copyright (C) 2005 K. Vasudevan. Indian Institute of Technology Kanpur.  */
/*   All Rights Reserved.                                                     */
/******************************************************************************/
extern FILE *fp1,*fp2,*fp3,*fp4,*fp5;                       /* File pointers. */
/******************************************************************************/
/*                     VARIABLES RELATED TO THE FRAME.
*******************************************************************************/
extern int Ber;                                            /* Bit-error-rate. */
extern int Valid_Bit;                                   /* Valid bit counter. */
extern int Erasure;                                         /* Frame erasure. */
extern int Tx_Samp_Cnt;                                /* Sample count at tx. */
extern int Rx_Samp_Cnt;                                /* Sample count at rx. */
extern int Frame_Cnt;                                         /* Frame count. */
extern int Sym[FRAME_SIZE];                                /* Stores symbols. */
extern double Map[BPSK_SIZE];                         /* Stores BPSK mapping. */
/******************************************************************************/
/*                        TRANSMIT FILTER VARIABLES.
*******************************************************************************/
extern double Rand_Tx_Delay;                                 /* Random delay. */
extern double Re_Tx_Op;                                       /* Re. tx. o/p. */
extern double Im_Tx_Op;                                       /* Im. tx. o/p. */
extern double Tx_Flt[TX_FLT_SIZE];                        /* Transmit filter. */
extern double Re_Tx_Reg[TX_FLT_SIZE];                         /* Re. tx. reg. */
extern double Im_Tx_Reg[TX_FLT_SIZE_1];                       /* Im. tx. reg. */
/******************************************************************************/
/*                  VARIABLES RELATED TO THE MODULATED SIGNAL.
*******************************************************************************/
extern double Passband_Signal[TX_SAMP_SIZE];              /* Passband signal. */
extern double Initial_Phase;                  /* Initial carrier phase at tx. */
extern double Theta;                             /* Starting phase at the tx. */
/******************************************************************************/
/*                       NOISE GENERATOR VARIABLES.
*******************************************************************************/
extern unsigned short N1_Store[PN_SIZE];                /* Stores PNS status. */
extern unsigned short N2_Store[PN_SIZE];                /* Stores PNS status. */
extern double Variance;                                    /* Noise variance. */
extern double Inv_Twice_Noise_Var;    /* Inverse of twice the noise variance. */
extern double N1_Val[NVALSIZE];                  /* Contains U & G rand. var. */
/******************************************************************************/
/*              VARIABLES RELATED TO FREQUENCY OFFSET ESTIMATION.
*******************************************************************************/
extern int Max_F_Off_Inx;                     /* Index corresponding to peak. */
extern double ISI_Coeff[ISI_LEN];                               /* ISI coeff. */
extern double ISI_Reg[ISI_LEN];                      /* Contains ISI symbols. */
extern double Im_ISI[PRE_AMB_SIZE];                         /* Im. ISI value. */
extern double Re_F_Off_Sum;                                 /* Re. diff. sum. */
extern double Im_F_Off_Sum;                                 /* Im. diff. sum. */
extern double Max_F_Off_Mag;                       /* Max. mag. of diff. sum. */
extern double Max_Re_F_Off_Sum;                        /* Max. re. diff. sum. */
extern double Max_Im_F_Off_Sum;                        /* Max. im. diff. sum. */
extern double Est_F_Off;                           /* Estimated freq. offset. */
extern double F_Off_RMS;                          /* RMS value of est. error. */
extern double Max_F_Off_Err;                   /* Absolute max. error in est. */
/******************************************************************************/
/*       VARIABLES RELATED TO FREQUENCY OFFSET ESTIMATION: 2nd ATTEMPT.
*******************************************************************************/
extern int Max_F_Off_Inx_2;      /* 2nd attempt: Index corresponding to peak. */
extern double Est_F_Off_2;            /* 2nd attempt: Estimated freq. offset. */
extern double F_Off_RMS_2;           /* 2nd attempt: RMS value of est. error. */
extern double Max_F_Off_Err_2;    /* 2nd attempt: Absolute max. error in est. */
/******************************************************************************/
/*       VARIABLES RELATED TO FREQUENCY OFFSET ESTIMATION: 3rd ATTEMPT.
*******************************************************************************/
extern int Max_F_Off_Inx_3;      /* 3rd attempt: Index corresponding to peak. */
extern double Est_F_Off_3;            /* 3rd attempt: Estimated freq. offset. */
extern double F_Off_RMS_3;           /* 3rd attempt: RMS value of est. error. */
extern double Max_F_Off_Err_3;    /* 3rd attempt: Absolute max. error in est. */
/******************************************************************************/
/*           VARIABLES RELATED TO ML FREQUENCY OFFSET ESTIMATION.
*******************************************************************************/
extern double Est_F_Off_ML;                   /* ML estimate of freq. offset. */
extern double Re_DFT;                                             /* Re. DFT. */
extern double Im_DFT;                                             /* Im. DFT. */
extern double Max_DFT_Mag;                                    /* Peak of DFT. */
/******************************************************************************/
/*               LOCAL OSCILLATOR (AT THE RECEIVER) VARIABLES.
*******************************************************************************/
extern double C_Theta;                                      /* Carrier phase. */
extern double Re_LO[LO_PERIOD];                         /* Cosine term of LO. */
extern double Im_LO[LO_PERIOD];                           /* Sine term of LO. */
extern double Re_LO_Op;                                        /* Re. LO o/p. */
extern double Im_LO_Op;                                        /* Im. LO o/p. */
/******************************************************************************/
/*                         MATCHED FILTER VARIABLES.
*******************************************************************************/
extern double Rx_Re_Sym1;                                  /* Rx. re. symbol. */
extern double Rx_Im_Sym1;                                  /* Rx. im. symbol. */
extern double Rx_Re_Sym2;                           /* Rx. re. offset symbol. */
extern double Rx_Im_Sym2;                           /* Rx. im. offset symbol. */
extern double MF[MF_SIZE];                                 /* Matched filter. */
extern double Re_MF_Reg[MF_SIZE];                              /* Re. MF reg. */
extern double Im_MF_Reg[MF_SIZE];                              /* Im. MF reg. */
extern double Re_MF_Op[RX_SAMP_SIZE];                          /* Re. MF o/p. */
extern double Im_MF_Op[RX_SAMP_SIZE];                          /* Im. MF o/p. */
/******************************************************************************/
/*                   TIMING AND CARRIER RECOVERY VARIABLES.
*******************************************************************************/
extern int Samp_Instant;                                 /* Sampling instant. */
extern double Est_Phase;                          /* Estimated carrier phase. */
extern double Cost;                                          /* Cosine value. */
extern double Sint;                                            /* Sine value. */
extern double Tim_Var;                                   /* Var. of tim. est. */
extern double Tim_Var_2;                    /* 2nd attempt: Var. of tim. est. */
extern double Tim_Var_3;                    /* 3rd attempt: Var. of tim. est. */
extern double Avg_Re_Amp;                              /* Avg. re. amplitude. */
extern double Avg_Im_Amp;                              /* Avg. im. amplitude. */
extern double Est_Var;                                 /* Estimated variance. */
/******************************************************************************/
