/******************************************************************************/
/*   Copyright (C) 2006 K. Vasudevan. Indian Institute of Technology Kanpur.  */
/*   All Rights Reserved.                                                     */
/******************************************************************************/
/******************************************************************************/
#include "deal4type.h"
#include "deal4ext.h"
/******************************************************************************/
/*               Estimate the frequency offset - 2nd attempt.
*******************************************************************************/
int Get_F_Off_2()
{
 Scan_Pre_Amb_2();
 if((Max_F_Off_Inx_2+(PRE_AMB_SIZE+SYM_SIZE-1)*RX_SAMP_PER_SYM)<RX_SAMP_SIZE)
 {
  Estimate_F_Off_2();
  if(RAND_TIM == ZERO)
   Update_Tim_Var_2();
 }
 Print_F_Off_2();
 return(0);
}
/******************************************************************************/
/*                          Scan for preamble.
*******************************************************************************/
int Scan_Pre_Amb_2()
{
 int cnt1,cnt2,inx;
 double mag;
 cnt1=Max_F_Off_Inx-RX_OFF;
 Max_F_Off_Mag=MIN_MAG;
 while(cnt1 < (Max_F_Off_Inx+RX_OFF))
 {
  inx=cnt1;
  Re_F_Off_Sum=Im_F_Off_Sum=FRAC_ZERO;
  for(cnt2=ZERO;cnt2<PRE_AMB_SS-ONE;cnt2++)
  {
   Update_F_Off_Sum(inx,cnt2);
   inx=inx+RX_SAMP_PER_SYM;
  }
  mag=Re_F_Off_Sum*Re_F_Off_Sum+Im_F_Off_Sum*Im_F_Off_Sum;
  if(Frame_Cnt == ZERO)
   fprintf(fp3,"%lf\n",mag);
  if(mag > Max_F_Off_Mag)
   Store_Max_2(cnt1,mag);
  cnt1++;
 }
 return(0);
}
/******************************************************************************/
/*              Store the maximum value of the differential sum.
*******************************************************************************/
int Store_Max_2(inx,mag)
int inx;
double mag;
{
 Max_F_Off_Mag=mag;
 Max_F_Off_Inx_2=inx;
 Max_Re_F_Off_Sum=Re_F_Off_Sum;
 Max_Im_F_Off_Sum=Im_F_Off_Sum;
 return(0);
}
/******************************************************************************/
/*                      Estimate the frequency offset.
*******************************************************************************/
int Estimate_F_Off_2()
{
 double theta,diff;
 if(fabs(Max_Im_F_Off_Sum) < fabs(Max_Re_F_Off_Sum))
 {
  theta=atan(Max_Im_F_Off_Sum/Max_Re_F_Off_Sum);
  if((Max_Im_F_Off_Sum > FRAC_ZERO) && (Max_Re_F_Off_Sum < FRAC_ZERO))
   theta=theta+M_PI;
  else if((Max_Im_F_Off_Sum < FRAC_ZERO) && (Max_Re_F_Off_Sum < FRAC_ZERO))
   theta=theta-M_PI;
 }
 else
 {
  theta=M_PI/2.0-atan(Max_Re_F_Off_Sum/Max_Im_F_Off_Sum);
  if(Max_Im_F_Off_Sum < FRAC_ZERO)
   theta=theta-M_PI;
 }
 Est_F_Off_2=theta/(double)(TX_IP_FAC);
 diff=fabs(F_OFF-Est_F_Off-Est_F_Off_2);
 F_Off_RMS_2=F_Off_RMS_2+diff*diff;
 if(diff > Max_F_Off_Err_2)
  Max_F_Off_Err_2=diff;
 return(0);
}
/******************************************************************************/
/*                        Update the timing variance.
*******************************************************************************/
int Update_Tim_Var_2()
{
 double correct_time,est_time;
 correct_time=(double)(TX_DELAY*RX_IP_FAC*TWO);
 est_time=(double)Max_F_Off_Inx_2;
 Tim_Var_2=Tim_Var_2+(correct_time-est_time)*(correct_time-est_time);
 return(0);
}
/******************************************************************************/
/*                        Print the frequency offset.
*******************************************************************************/
int Print_F_Off_2()
{
 printf("\t Time:%d Max Re:%lf ",Max_F_Off_Inx_2,Max_Re_F_Off_Sum);
 printf("Max Im:%lf ",Max_Im_F_Off_Sum);
 printf("Freq Off:%lf\n",Est_F_Off_2);
 fflush(stdout);
 return(0);
}
/******************************************************************************/
