#*******************************************************************************
#    Copyright (C) 2008 K. Vasudevan. Indian Institute of Technology Kanpur.
#    All Rights Reserved.
#*******************************************************************************
# Plot of the maximum frequency offset error vs SNR. Freq. offset is 30% of
# the symbol-rate.
#*******************************************************************************
#*******************************************************************************
# Gnuplot file. To plot the graph run gnuplot and at the gnuplot prompt
# type: load "maxfoff_3T.gp"<RETURN>
# If you want the output on the screen, comment the following two lines:
# set term postscript eps color 22
# set output "maxfoff_3T.eps"
# Comment lines begin with a #.
# For help on gnuplot, run gnuplot and type the following at the gnuplot
# prompt: help
#*******************************************************************************
set term postscript eps color 22
set key box
set grid xtics ytics mytics lw 0.5, lw 0.5
set format y "%2.1e"
set output "maxfoff_3T.eps"
set logscale y
#set xlabel "E_b/N_0 (dB)"
#set ylabel "Bit error rate"
plot "maxfoff1_3T.dat" t\
     "Diff. corr. 1st attempt"\
      w linespoints lt -1 lw 1 pt 1,\
     "maxfoff2_3T.dat" t "Diff. corr. 2nd attempt"\
      w linespoints lt -1 lw 1 pt 2,\
     "maxfoff3_3T.dat" t "ML 1st stage"\
      w linespoints lt -1 lw 1 pt 3,\
     "maxfoff4_3T.dat" t "ML 2nd stage"\
      w linespoints lt -1 lw 1 pt 4
